/***************************************************************************
 *   Copyright (C) 2004 by Maciej "Kasprzol" Kasprzyk                      *
 *   katalogue@katalogue.szluug.org                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef FINDFILEDIALOG_H
#define FINDFILEDIALOG_H

#include <kdialogbase.h>

class QLineEdit ;
class QLabel ;
class QCheckBox ;
class MyKatalog ;
class MyDirInfo ;
class TreeView ;
class QRegExp ;

/**
@author Maciej "Kasprzol" Kasprzyk
*/
class FindFileDialog : public KDialogBase
{
Q_OBJECT
public:
    FindFileDialog (QWidget *parent, MyKatalog * myk) ;

    ~FindFileDialog () ;
private: // Private attributes
  /** line edit zawierajcy nazw (regexp) poszukiwanego pliku */
  QLineEdit * m_le_regexp ;
  QLabel * label1 ;
  QLabel * label2 ;
  QCheckBox * m_ch_perl ;
  TreeView * m_treeview ;
  MyKatalog * m_katalog ;
  void SearchDirForRegexp (const MyDirInfo * mdi, const QRegExp & regexp) ;
protected slots: // Protected slots
  /** No descriptions */
  void slotOk () ;
};

#endif
