/***************************************************************************
 *   Copyright (C) 2004 by Maciej "Kasprzol" Kasprzyk                      *
 *   katalogue@katalogue.szluug.org                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef MYDOCUMENT_H
#define MYDOCUMENT_H

#include <string>
#include <klocale.h>
#include "mydirinfo.h"

/**
 * przechowuje obiekt MyKatalog i wszelkie potrzebne informacje o nim (czy zmodyfikowany, przypisana anzwa pliku itp.)
 **/
/**
@author Maciej "Kasprzol" Kasprzyk
*/
class MyDocument
{
private:
	MyKatalog * m_katalog ;
	bool m_modified ;
	std::string m_filename ;
public:
	MyDocument() : m_katalog ( new MyKatalog ( i18n ("New catalogue").local8Bit ().operator const char * () ) ), m_modified (false) { }
	~MyDocument() { delete m_katalog ; }
	MyKatalog * katalog () { return m_katalog ; }
	void setFileName (std::string newfilename) { m_filename = newfilename ; }
	void fileName (std::string newfilename) { m_filename = newfilename ; }
	std::string fileName () { return m_filename ; }
	void save ()
	{
		m_katalog->SaveToFile (m_filename.c_str ()) ;
		m_modified = false ;
	}
	void saveAs (const std::string newfilename)
	{
		m_filename = newfilename ;
		save () ;
	}
	void load (const  std::string newfilename) ;
	void newDoc ()
	{
		delete m_katalog ;
		new (this) MyDocument ;
	}
  /**
  Ustawia flag modyfikacji katalogu
  */
  void setModified (bool mod) { m_modified = mod ; }
  void modified (bool mod) { m_modified = mod ; }
  bool modified () { return m_modified ; }
};

#endif
