/***************************************************************************
 *   Copyright (C) 2004 by Maciej "Kasprzol" Kasprzyk                      *
 *   katalogue@katalogue.szluug.org                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef SCANDIRDIALOG_H
#define SCANDIRDIALOG_H

#include <qwidget.h>
#include <kdialogbase.h>

class QLineEdit ;
class MyKatalog ;
class BaseClass ;

/**
@author Maciej "Kasprzol" Kasprzyk
*/
class ScanDirDialog : public KDialogBase  {
   Q_OBJECT
public: 
	ScanDirDialog(QWidget *parent, MyKatalog * myk);
	~ScanDirDialog() { }
  /** zwraca wpisan ciek */
  QString path () const { return m_dir ; } 
  /** zwraca wpisan nazw */
  QString name () const { return m_name ; }
  /** zwraca wskanik do wybranej grupy lub do katalogu */
  BaseClass * group () ;
  
private slots: // Private slots
  /** No descriptions */
  void slotBrowseButton() ;
  
private: // Private attributes
  /** wskanik na line edit zawierajcy ciek do katalogu do skanowania */
  QLineEdit * m_le_scandir ;
  /** wskanik na line edit zawierajcy nazw nadan nowo skanowanemu katalogowi */
  QLineEdit * m_le_name ;
  /**  */
  QComboBox * m_combobox ;
  /**  */
  MyKatalog * m_mykatalog ;
  /**  */
  QString m_dir ;
  /**  */
  QString m_name ;
  /**  */
  int comboindex ;

protected slots: // Protected slots
  /** No descriptions */
  void slotOk () ;
  /** No descriptions */
  void slotCancel () ;
};

#endif
