/***************************************************************************
 *   Copyright (C) 2004 by Maciej "Kasprzol" Kasprzyk                      *
 *   katalogue@katalogue.szluug.org                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef TREEVIEW_H
#define TREEVIEW_H


//#include <qlistview.h>
#include <klistview.h>
#include <qstring.h>
//#include <qfileinfo.h>
//#include <qtimer.h>

/*
class QDragEnterEvent;
class QDragMoveEvent;
class QDragLeaveEvent;
class QDropEvent;
*/
class BaseClass ;
class TreeView ;

/**
@author Maciej "Kasprzol" Kasprzyk
*/
class TreeItem : public KListViewItem
{
public:
    TreeItem( KListView * parent, const QString& new_title, BaseClass * p ) ;
    TreeItem( TreeItem * parent, const QString& new_title, BaseClass * p ) ;
    TreeItem( KListView * parent, BaseClass * p ) ;
    TreeItem( TreeItem * parent, BaseClass * p ) ;

//    QString text () const;

    void setOpen( bool );

    const QPixmap *pixmap( int i ) const;
    void setPixmap( QPixmap *p );

    int compare (QListViewItem * i, int col, bool ascending) const ;
    
    BaseClass * getItem () const { return item ; }
private:
    BaseClass * item ;
    QString title ;
    TreeItem * parent_treeitem ;
    KListView * parent_listview ;
    QPixmap *pix;
};

/**
@author Maciej "Kasprzol" Kasprzyk
*/
class TreeView : public KListView
{
    Q_OBJECT

public:
    TreeView( QWidget *parent = 0, const char *name = 0 );
    static void deInitIconCache () ;
    static void initIconCache () ;

public slots:
//    void setDir( const QString & );
    void setDir( const BaseClass * );

signals:
//    void TreeItemSelected( const QString & );
    void TreeItemSelected( const TreeItem & );
    void itemRenamed( TreeItem *, const QString & ) ;

protected slots:
    void slotTreeItemSelected( QListViewItem * );
    void slotItemRenamed( QListViewItem * item, int col, const QString & text ) ;
//    void openFolder();

protected:
/*
    void contentsDragEnterEvent( QDragEnterEvent *e );
    void contentsDragMoveEvent( QDragMoveEvent *e );
    void contentsDragLeaveEvent( QDragLeaveEvent *e );
    void contentsDropEvent( QDropEvent *e );
    void contentsMouseMoveEvent( QMouseEvent *e );
    void contentsMousePressEvent( QMouseEvent *e );
    void contentsMouseReleaseEvent( QMouseEvent *e );
*/
private:
//    QString fullPath(QListViewItem* item);
//    QListViewItem *oldCurrent;
//    QListViewItem *dropItem;
//    QTimer* autoopen_timer;
//    QPoint presspos;
//    bool mousePressed;

};

#endif
